// AecMfcUSBDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AecMfcUSB.h"
#include "AecMfcUSBDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Shortcut macros 

        // AecPciOpenDevice - get a handle to PCI device driver
        //     In: n  - device number 0 - max
        //                  (0 opens "AecPci0" device)
        //     Out: returns - HANDLE to device or
        //              INVALID_HANDLE_VALUE if there is an error.

#define OpenAecUsbDevice(n)\
            CreateFile("\\\\.\\AecUsbTCDevice"#n,\
                0, FILE_SHARE_READ | FILE_SHARE_WRITE,\
                NULL, OPEN_EXISTING, 0, NULL)  


GUID m_ClassGuid = AecUsbTCDevice_CLASS_GUID;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAecMfcUSBDlg dialog

CAecMfcUSBDlg::CAecMfcUSBDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAecMfcUSBDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAecMfcUSBDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

}

CAecMfcUSBDlg::~CAecMfcUSBDlg()
{
    if (!CloseHandle(m_hAecDevice))           // Close the Device "file".
    {
        //printf("Failed to close device.\n");
		MessageBox("Unable to Close the Aec USB device.",
			NULL, MB_ICONSTOP | MB_OK);
    }
	//KillTimer(m_Dlg_Timer);

}

void CAecMfcUSBDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAecMfcUSBDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAecMfcUSBDlg, CDialog)
	//{{AFX_MSG_MAP(CAecMfcUSBDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_QUICKREAD, OnButtonQuickread)
	ON_BN_CLICKED(IDC_CHECK_INTENABLE_L21, OnCheckIntenableL21)
	ON_BN_CLICKED(IDC_CHECK_INTENABLE_COMPARE, OnCheckIntenableCompare)
	ON_BN_CLICKED(IDC_CHECK_INTENABLE_VIDEO, OnCheckIntenableVideo)
	ON_BN_CLICKED(IDC_CHECK_INTENABLE_READER, OnCheckIntenableReader)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_ZEROVID, OnButtonZerovid)
	ON_BN_CLICKED(IDC_BUTTON_R1, OnButtonR1Go)
	ON_BN_CLICKED(IDC_BUTTON_R4, OnButtonR4Go)
	ON_BN_CLICKED(IDC_BUTTON_W1, OnButtonW1Go)
	ON_BN_CLICKED(IDC_BUTTON_W4, OnButtonW4Go)
	ON_BN_CLICKED(IDC_BUTTON_CMD, OnButtonCmdGo)
	ON_BN_CLICKED(IDC_CHECK_TIMERSTOP, OnCheckTimerstop)
	ON_BN_CLICKED(IDC_CHECK_SLOWMO, OnCheckSlowmo)
	ON_BN_CLICKED(IDC_BUTTON_L21, OnButtonL21)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAecMfcUSBDlg message handlers

BOOL CAecMfcUSBDlg::OnInitDialog()
{
	DWORD	Error;
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	//AEC...
	m_hAecDevice = INVALID_HANDLE_VALUE;
	//m_ClassGuid = AecUsbTCDevice_CLASS_GUID;

	m_hAecDevice = OpenAecUsbDevice(0);
	//m_hAecDevice = OpenByInterface( &m_ClassGuid, 0, &Error);
    if (m_hAecDevice == INVALID_HANDLE_VALUE)        // Was the device opened?
    {
        //printf("Unable to open the device.\n");
		//int MessageBox(HWND hWnd, LPCTSTR lpText, LPCTSTR lpCaption, UINT uType); 
		//iMB = MessageBox(hwnd, "Unable to open the Aec USB device.",
		//	NULL, //default is "Error" if null "Caption-Unable to open the device.\n", 
		//	MB_ICONSTOP | MB_OK); 
		MessageBox("Unable to open the Aec USB device.",
			NULL, //default is "Error" if null "Caption-Unable to open the device.\n", 
			MB_ICONSTOP | MB_OK);

        exit(1);
    }	
	else
	{
/*++ //debug
		m_vidcount = 0;
		SndCmd(0x00);	//pre-initialize "interrupt-clear" messageing
		//Interupt Enables (2E)==========================================
		Sleep(100);
		BYTE temp = R1(0x2E);
		//7
		CheckDlgButton(IDC_CHECK_INTENABLE_L21, ((temp & 0x40) ? 1 : 0));
		CheckDlgButton(IDC_CHECK_INTENABLE_COMPARE, ((temp & 0x20) ? 1 : 0));
		//4

		//3
		//2
		CheckDlgButton(IDC_CHECK_INTENABLE_VIDEO, ((temp & 0x02)  ? 1 : 0 ));
		CheckDlgButton(IDC_CHECK_INTENABLE_READER, ((temp & 0x01)  ? 1 : 0 ));
		m_cmp2E = temp;
//--*/

		m_StopPolling = false;
		m_Dlg_Timer = SetTimer(1, 3000, 0);	//Get the polling loop going!

		//slowmo?
		BYTE b = R1(0x00FC);
		if ((b & 0x0010) != 0)
			m_slowmo = true;
		else m_slowmo = false;
		CheckDlgButton(IDC_CHECK_SLOWMO, (m_slowmo  ? 1 : 0 ));
	}
	return TRUE;  // return TRUE  unless you set the focus to a control
}
/*



	m_hAecDevice = OpenByInterface( &m_ClassGuid, 0, &Error);
    if (m_hAecDevice == INVALID_HANDLE_VALUE)        // Was the device opened?
    {
        //printf("Unable to open the device.\n");
		//int MessageBox(HWND hWnd, LPCTSTR lpText, LPCTSTR lpCaption, UINT uType); 
		iMB = MessageBox(hwnd, "Unable to open the Aec PCI device.",
			NULL, //default is "Error" if null "Caption-Unable to open the device.\n", 
			MB_ICONSTOP | MB_OK); 

        exit(1);
    }
	else 
	{
		returnval1 = TRUE;
	}





  //----------------------------------
	static char title_id[60];
	char AddrStr[10];
	m_cmpRtb = 0xFFFFFFFF;
	m_cmpRub = 0xFF0FFFFF;
	cmpGtb = 0xFFFFFFFF;
	cmpGub = 0xFF0FFFFF;
	m_cmpReb = 0xFF;
	cmpGeb = 0xFF;



	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	//do PC-TC stuff and then start the timer

	//new---> here to end of func.

	boardNum = tc1.GetCountRegistered();	//
	if (tc1.GetCountFound() != 0)
	{
		iSelected = 0;	//the CAec class sets this program to use the FIRST board
						//that is FOUND by search (0 based index)
		strcpy(title_str, title_strBase);
		strcat(title_str, tc1.GetStrId(title_id));
		strcat(title_str, " (Address ");
		strcat(title_str, sh1.WStr(tc1.BrdAddr(), AddrStr));
		strcat(title_str, ")");
	}
	else 	strcat(title_str, "(no board found)");

    lpPassToAECDLLrev = (LPSTR) &rev;
	aecint = tc1.GetDll_info(lpPassToAECDLLrev);
	//wsprintf (dllinfo,"AEC_NTTC.DLL Rev. %c%c - ", rev[0], rev[1]);
	wsprintf (dllinfo," AEC_NTTC.DLL '%c%c'", rev[0], rev[1]);

	strcat(title_str, dllinfo);
	SetDlgItemText(IDC_EDIT_BRD_INFO, title_str);
		// **NEW**
		// This is important!! Make this program has the Priority that you
		// want it to have. I have decided that I want this program to run
		// as close as possible to REAL_TIME (highest Priority)
		// or interrupts will not be processed quickly enough
	SetPriorityClass( GetCurrentProcess(), REALTIME_PRIORITY_CLASS );

	//11-25-02 ADD NEXT BACK
	tc1.OrIntEnables(0x3F);	//set all bits of int enables - bits 0-6	
	//11-25-02 CLR NEXT 
	//tc1.AndIntEnables(0x00);	//clear all enables

	OnButtonVidCountZero();
	InitStatus_N_Signals();

	//11-25-02 ADD NEXT BACK
	InitGenStatusAll();

	m_Dlg_Timer = SetTimer(1, 300, 0);
	//KillTimer(m_Dlg_Timer);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
*/

void CAecMfcUSBDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CAecMfcUSBDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAecMfcUSBDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CAecMfcUSBDlg::OnButtonQuickread() 
{
		//time
		m_cmpRtb = R4(0x0010);//tc1.GetTimeRead(); //tc1.tcR.t;
		LtoStrTm(m_cmpRtb, hhmmssff);
		SetDlgItemText(IDC_EDIT_TIME, hhmmssff);
		//user
		m_cmpRub = R4(0x0014);//tc1.GetUserRead(); //tc1.tcR.u;	
		LtoStrTm(m_cmpRub, hhmmssff);
		SetDlgItemText(IDC_EDIT_USER, hhmmssff);
		//embedded	//tc1.tcR.e 
		//m_cmpReb = (tc1.GetEBRead() & 0xF3); //mask the field (bit3/2 (NTSC/PAL)) to limit updates
		m_cmpReb = (R1(0x0018) & 0xF3); //mask the field (bit3/2 (NTSC/PAL)) to limit updates
		if (m_cmpReb & 0x80)
			SetDlgItemText(IDC_EDIT_DF, "YES");
		else SetDlgItemText(IDC_EDIT_DF, "NO");
		if (m_cmpReb & 0x40)
			SetDlgItemText(IDC_EDIT_CF, "YES");
		else SetDlgItemText(IDC_EDIT_CF, "NO");		
}

//==========================================================
void CAecMfcUSBDlg::OnCheckIntenableL21() 
{
	// TODO: Add your control notification handler code here
//IDC_CHECK_INTENABLE_L21	
	BYTE b2E = R1(0x2E);

	if (IsDlgButtonChecked(IDC_CHECK_INTENABLE_L21))
		b2E = (b2E | BIT6);
//		tc1.OrIntEnables(BIT0); (b | BIT1);
//	else tc1.AndIntEnables(NOTBIT0);	cmd & 0xF0
	else b2E = (b2E & 0xBF);
	W1(0x2E, b2E);
}

//==========================================================
void CAecMfcUSBDlg::OnCheckIntenableCompare() 
{
	// TODO: Add your control notification handler code here
//IDC_CHECK_INTENABLE_COMPARE	
	BYTE b2E = R1(0x2E);

	if (IsDlgButtonChecked(IDC_CHECK_INTENABLE_COMPARE))
		b2E = (b2E | BIT5);
//		tc1.OrIntEnables(BIT0); (b | BIT1);
//	else tc1.AndIntEnables(NOTBIT0);	cmd & 0xF0
	else b2E = (b2E & 0xDF);
	W1(0x2E, b2E);
}

//==========================================================
void CAecMfcUSBDlg::OnCheckIntenableVideo() 
{
	// TODO: Add your control notification handler code here
//IDC_CHECK_INTENABLE_VIDEO	
	BYTE b2E = R1(0x2E);

		if (IsDlgButtonChecked(IDC_CHECK_INTENABLE_VIDEO))
		b2E = (b2E | BIT1);
//		tc1.OrIntEnables(BIT0); (b | BIT1);
//	else tc1.AndIntEnables(NOTBIT0);	cmd & 0xF0
	else b2E = (b2E & 0xFD);
	W1(0x2E, b2E);
}

//==========================================================
void CAecMfcUSBDlg::OnCheckIntenableReader() 
{
	// TODO: Add your control notification handler code here

	// set/clear interrupt enable register bit0
	BYTE b2E = R1(0x2E);

//IDC_CHECK_INTENABLE_READER
	if (IsDlgButtonChecked(IDC_CHECK_INTENABLE_READER))
		b2E = (b2E | BIT0);
//		tc1.OrIntEnables(BIT0); (b | BIT1);
//	else tc1.AndIntEnables(NOTBIT0);	cmd & 0xF0
	else b2E = (b2E & 0xFE);
	W1(0x2E, b2E);
}

//==========================================================
void CAecMfcUSBDlg::OnTimer(UINT nIDEvent) 
{
	//CDialog::OnTimer(nIDEvent);
	BYTE tempP, tempE, temp;
	int i = 0;
	BOOL bGotInt = false;
	BOOL bGot1Int = false;
	temp = 0;
	KillTimer(m_Dlg_Timer);
	if (nIDEvent == 1)
	{
//		if (!m_StopPolling)	//if false
//		{

			do 
			{
				bGotInt = Poll_And_Process();
				//Sleep(1); //added 7/03 for new driver debugging
			//	tempP = R1(0x000E);	//pci/usb	//int pending?
			//	tempE = R1(0x002E);
			//	temp = (tempP & tempE);
				i++;
				if (bGotInt)
					bGot1Int = true;

			//} while ((bGotInt || tc1.PendingIntBuffered())  && (i < 10));
			//} while ((bGotInt)  && (i < 2));
			//} while ((bGotInt)  && (i < 5));
			} while (bGotInt  && (i < 10));
			//} while ((bGotInt || temp)  && (i < 5));


			//if (bGot1Int)
			m_IntUpdateCounter++;
			if (m_IntUpdateCounter > 50)
			{
				m_IntUpdateCounter = 0;
				UpdateStatus_N_Signals();		
				//MessageBeep(0xFFFFFFFF);
			}
	//		if (i == 10)
	//		{
	//			i = 0;
	//			//MessageBeep(0xFFFFFFFF);
	//		}
			//MessageBeep(MB_OK);	//this works to get "bum!!!"
			//11-25-02 ADD NEXT BACK
//			if (!m_StopPolling)	//if false
//				m_Dlg_Timer = SetTimer(1, 25, 0);
//		}
	}
	if (!m_StopPolling)	//if false
		m_Dlg_Timer = SetTimer(1, 10, 0);
	return;
}

//==========================================================
void CAecMfcUSBDlg::OnCheckTimerstop() 
{
	if (IsDlgButtonChecked(IDC_CHECK_TIMERSTOP))
	{
		m_StopPolling = true;
		KillTimer(m_Dlg_Timer);
	}
	else
	{
		Sleep(50);
		m_StopPolling = false;
		m_Dlg_Timer = SetTimer(1, 10, 0);	//15
	}
}
//==========================================================

void CAecMfcUSBDlg::OnButtonZerovid() 
{
		//tc1.vidCounter = 0;
		m_vidcount = 0;
		//SetDlgItemText(IDC_EDIT_VID_FPS, "0");
		SetDlgItemText(IDC_EDIT_FIELDCNT, "0");
		//tmrVid.Zero();		
}

/*
void CAecMfc32TimeCodeDlg::OnButtonCmpstart() 
{
	// TODO: Add code to get the edit box compare time and
	//	start the comparator, then set the edit box 1d/2e edit
	//	box with status bits from reads at those addresses.
	// Also set the status of "IDC_CHECK_CMPSTATUS" check box 
	// IDC_EDIT_1B_2D_READ
	BYTE b2Da, b2Db, b1B;
	int i;

	if (GetDlgItemText(IDC_EDIT_CMPINPUT, sBuffer, 12))
	{
		// get compare string DATA DWORD
		dWfour = (DWORD)sh1.ToHex(sBuffer);
		// write packed BCD data to compare registers
		bWrite = tc1.SetComparatorTime(dWfour);
		// enable the comparator 
		// 0x09 = Exact match + any ">" than under 1 sec.

		b2Da = R1(0x002D); //TEMP
		b1B = tc1.GetCmpStatus();
		i = ((b1B & BIT7) ? 0 : 1);		
		//THIS IS REVERSE (next line makes state TOGGLE (active/inactive))

		bWrite = tc1.StartComparator(0x09);	//byte data does NOT do anything for PCI		

		b2Db = R1(0x002D); //TEMP


		LtoStrTm(dWfour, hhmmssff);
		SetDlgItemText(IDC_EDIT_CMPINPUT, hhmmssff);
	}
	else SetDlgItemText(IDC_EDIT_CMPINPUT, "Error");  	

//	Sleep(15);	//allow time for cmp status to update
//	b1B = tc1.GetCmpStatus();
//	int i = ((b1B & BIT7) ? 1 : 0);
	//int i = ((tc1.GetCmpStatus() & BIT7) ? 1 : 0);
	CheckDlgButton(IDC_CHECK_CMPSTATUS, i);
	//CheckDlgButton(IDC_CHECK_CMPSTATUS, ((tc1.GetCmpStatus() & BIT7) ? 1 : 0));

	if (i)
		SetDlgItemText(IDC_BUTTON_CMPSTART, "Disable/Stop");
	else  SetDlgItemText(IDC_BUTTON_CMPSTART, "Enable/Start");



	wsprintf (hhmmssff,"%2.2X,%2.2X-%2.2X", b1B, b2Da, b2Db);
	SetDlgItemText(IDC_EDIT_1B_2D_READ, hhmmssff);

	//wsprintf (cBuff,"v%d", iFieldsTotal);
	//wsprintf (hhmmssff,"Nak Error %2.2X", b1B, b2D);

	//IDC_CHECK_CMPSTATUS (active checkbox)
	//IDC_EDIT_1B_2D_READ
	//IDC_EDIT_CMPINPUT (edit box for input)
	//IDC_RADIO_CMPREAD
	//IDC_RADIO_CMPGEN
	
}
*/

/*
//=======================================================================
void CAecMfc32TimeCodeDlg::InitStatus_N_Signals()
{
	BYTE temp;

	//VERIFY(buttonUP.SubclassDlgItem(IDC_BUTTON_ICON_TEST, this));
	//buttonUP.SizeToContent();




	//GetDlgItem(IDC_BUTTON_ICON_TEST)->SendMessage(BM_SETIMAGE, IMAGE_ICON, IDI_ICON_UP);
	//temp ICON
	//hIcon = LoadIcon(
	//GetDlgItem(IDC_BUTTON_ICON_TEST)->SetIcon(
//	GetDlgItem(IDC_BUTTON_ICON_TEST)->SetIcon( ::LoadIcon(NULL,MAKEINTRESOURCE(IDI_ICON_UP)), FALSE);
	//GetDlgItem(IDC_BUTTON_ICON_TEST)->(  LoadIcon(NULL, IDI_ICON_UP);// EnableWindow(FALSE);
	//SendDlgItemMessage(IDC_BUTTON_ICON_TEST,BM_SETIMAGE, IMAGE_ICON, IDI_ICON_UP);

	//x hI = LoadIcon(NULL,MAKEINTRESOURCE(IDI_ICON_UP));
//	hI = GetDlgItem(IDC_BUTTON_ICON_TEST)->GetIcon(FALSE);
	

	if (!(filmAble = tc1.FilmAble()))
		GetDlgItem(IDC_BUTTON_DO_FILM)->EnableWindow(FALSE); 
	else GetDlgItem(IDC_BUTTON_DO_FILM)->EnableWindow(TRUE); 

	//Operating mode status (0Dh)=====================================
	temp = tc1.ModeStatus();
//	if (tc1.BrdType() == 4)	//PCI
//		temp = R1(0x000D);	//pci
//	else 
//		temp = R1(0x03E8);   //isa
	
	CheckDlgButton(IDC_CHECK_DIAGMODE, ((temp & 0x80) ? 1 : 0));
	//CheckDlgButton(nID, ((temp & 0x40) ? 1 : 0));	//see a few lines below
	CheckDlgButton(IDC_CHECK_LTCSELECTMODE, ((temp & 0x20) ? 1 : 0));
	CheckDlgButton(IDC_CHECK_VITCSELECTMODE, ((temp & 0x20) ? 0 : 1));

	//IDC_CHECK_FILMMODE
	if (filmAble)
	{
		if (temp & 0x40) //we are in FILM/HD (24fps) mode
		{
			CheckDlgButton(IDC_CHECK_FILMMODE, 1);
			CheckDlgButton(IDC_CHECK_EBUMODE, 0);
			CheckDlgButton(IDC_CHECK_SMPTEMODE, 0);
		}
		else
		{
			CheckDlgButton(IDC_CHECK_FILMMODE, 0);
			CheckDlgButton(IDC_CHECK_EBUMODE, ((temp & 0x10) ? 1 : 0));
			CheckDlgButton(IDC_CHECK_SMPTEMODE, ((temp & 0x10) ? 0 : 1));
		}
	}

	CheckDlgButton(IDC_CHECK_VGENMODE, ((temp & 0x08)  ? 1 : 0 ));
	CheckDlgButton(IDC_CHECK_LGENMODE, ((temp & 0x04)  ? 1 : 0 ));
	CheckDlgButton(IDC_CHECK_VL21RDRMODE, ((temp & 0x02)  ? 1 : 0 ));
	CheckDlgButton(IDC_CHECK_LRDRMODE, ((temp & 0x01)  ? 1 : 0 ));

	m_cmp0D = temp;

	if (tc1.GensVitc())
		CheckDlgButton(IDC_CHECK_GEN_VITC, ((temp & 0x08)  ? 1 : 0 ));
	else GetDlgItem(IDC_CHECK_GEN_VITC)->EnableWindow(FALSE);
	if (tc1.GensLtc())
		CheckDlgButton(IDC_CHECK_GEN_LTC, ((temp & 0x04)  ? 1 : 0 ));
	else GetDlgItem(IDC_CHECK_GEN_LTC)->EnableWindow(FALSE);
	if (tc1.ReadsVitc())
		CheckDlgButton(IDC_CHECK_READ_VITC, ((temp & 0x02)  ? 1 : 0 ));
	else GetDlgItem(IDC_CHECK_READ_VITC)->EnableWindow(FALSE);
	if (tc1.ReadsLtc())
		CheckDlgButton(IDC_CHECK_READ_LTC, ((temp & 0x01)  ? 1 : 0 ));
	else GetDlgItem(IDC_CHECK_READ_LTC)->EnableWindow(FALSE);

	
	//signal status (0Ch)==========================================
	if (tc1.BrdType() == 4)	//PCI
		temp = (R1(0x000C) & 0x7F);   //pci, mask bit7
			//		 bits  => 6=L21 input data OK,
							//5=VITC input data OK
							//4=LTC input data OK
							//3=Wide sync pluses detected
							//2=
							//1=odd video field
							//0=video input OK
	else 
		temp = (R1(0x0049) & 0x1F);   //isa, mask bits 7/6/5

							//4=LTC input data OK
							//3=Wide sync pluses detected
							//2=
							//1=odd video field
							//0=video input OK

	//CheckDlgButton(nID, ((temp & 0x80)  ? 1 : 0 ));
	CheckDlgButton(IDC_CHECK_L21STAT, ((temp & 0x40)  ? 1 : 0 ));
	CheckDlgButton(IDC_CHECK_VITCSTAT, ((temp & 0x20)  ? 1 : 0 ));
	CheckDlgButton(IDC_CHECK_LTCSTAT, ((temp & 0x10)  ? 1 : 0 ));

	CheckDlgButton(IDC_CHECK_VSYNCSTAT, ((temp & 0x08)  ? 1 : 0 ));
	//CheckDlgButton(nID, ((temp & 0x04)  ? 1 : 0 ));
//	if ((temp & 0x01))	//check the video OK first
//		CheckDlgButton(IDC_CHECK_FIELDSTAT, ((temp & 0x02)  ? 1 : 0 ));
//	else CheckDlgButton(IDC_CHECK_FIELDSTAT, 0);	//turn OFF
	CheckDlgButton(IDC_CHECK_VIDSTAT, ((temp & 0x01)  ? 1 : 0 ));
	m_cmp0C = temp;


	//Interupt Enables (2E)==========================================
	temp = (R1(0x002E) & 0x7F);   //mask bit7
			//		 bits  => 6= L21 Data Reader
							//5= TC comparator
							//4= Serial RX
							//3= Serial TX
							//2= TC Gen
							//1= video Field 
							//0= TC Reader 
	//CheckDlgButton(nID, ((temp & 0x80) ? 1 : 0));
	CheckDlgButton(AEC_CHECK_INT_L21ON, ((temp & 0x40) ? 1 : 0));
	CheckDlgButton(AEC_CHECK_INT_CMPON, ((temp & 0x20) ? 1 : 0));
	CheckDlgButton(AEC_CHECK_INT_RXON, ((temp & 0x10) ? 1 : 0));

	CheckDlgButton(AEC_CHECK_INT_TXON, ((temp & 0x08)  ? 1 : 0 ));
	CheckDlgButton(AEC_CHECK_INT_GENON, ((temp & 0x04)  ? 1 : 0 ));
	CheckDlgButton(AEC_CHECK_INT_VIDON, ((temp & 0x02)  ? 1 : 0 ));
	CheckDlgButton(AEC_CHECK_INT_RDRON, ((temp & 0x01)  ? 1 : 0 ));
	m_cmp2E = temp;


	//GetDlgItem(IDC_CHECK_SIO_GENERIC_DLG)->EnableWindow(FALSE);
	//GetDlgItem(IDC_CHECK_SONY422_DLG)->EnableWindow(FALSE);
	//GetDlgItem(IDC_CHECK_L21_DLGBOX)->EnableWindow(FALSE);
	//GetDlgItem(IDC_CHECK_ISR_ONLY)->EnableWindow(FALSE);

}

				
*/

// ======================================================================
// OpenByInterface
//
// Opens nth device found (enumerated) with the given interface class
// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
HANDLE CAecMfcUSBDlg::OpenByInterface(GUID *pClassGuid, DWORD instance, PDWORD pError)
{
	HANDLE hDev;
	CDeviceInterfaceClass DevClass(pClassGuid, pError);

	if (*pError != ERROR_SUCCESS)
		return INVALID_HANDLE_VALUE;

	CDeviceInterface DevInterface(&DevClass, instance, pError);

	if (*pError != ERROR_SUCCESS)
		return INVALID_HANDLE_VALUE;

	hDev = CreateFile(
		DevInterface.DevicePath(),
		GENERIC_READ | GENERIC_WRITE,
		FILE_SHARE_READ | FILE_SHARE_WRITE,
		NULL,
		OPEN_EXISTING,
		FILE_ATTRIBUTE_NORMAL,
		NULL
		);

	if (hDev == INVALID_HANDLE_VALUE)
		*pError = GetLastError();

	return hDev;
}

// ======================================================================
void CAecMfcUSBDlg::OnOK() 
{
	// TODO: Add extra validation here
	CDialog::OnOK();
}

// ======================================================================
BOOL CAecMfcUSBDlg::Poll_And_Process()
{
	BOOL	bEvent = false;
	ULONG		pAddr, d4, dLn;
	BOOLEAN		IOResult;
	BOOLEAN		status;
	UCHAR		iCd;

	status = TRUE;
	pAddr = 0x00000010;
	d4 = 0x00000000;
	//POLLED method
	IOResult = CheckForInt();
	if (IOResult != 0)
	{
		ProcessIntEventCode(IOResult);
		bEvent = true;
	}
/*
			if (tc1.Any_event()) 
			{	
				bEvent = TRUE;
				// go process the "events"
				if (tc1.brk_event)
 				{
					tc1.brk_event = FALSE;
					ProcessIntEventCode(0x8A);
				}
				if (tc1.tx_event)
				{
					tc1.tx_event = FALSE;
					ProcessIntEventCode(0x89);
				}
				if (tc1.nak_event)
				{
					tc1.nak_event = FALSE;
					tc1.cmd_event = FALSE;	//only ONE value is saved in cmd_ret
					ProcessIntEventCode(tc1.cmd_ret);
				}
				if (tc1.cmd_event)
				{
					tc1.cmd_event = FALSE;
					ProcessIntEventCode(tc1.cmd_ret);
				}
				if (tc1.cmp_event)
				{
					tc1.cmp_event = FALSE;
					ProcessIntEventCode(0x50);
				}
				if (tc1.rx_event)
				{
					tc1.rx_event = FALSE;
					ProcessIntEventCode(0x88);
					//RXready = TRUE;
					//if (RXready && IsWindow(hwndSIO))
					//	ProcessRXready(hwnd, rx_mode);

				}
				if (tc1.gen_event)
				{
					tc1.gen_event = FALSE;
					ProcessIntEventCode(0x4C);
				}
				if (tc1.vid_event)
				{
					tc1.vid_event = FALSE;
					ProcessIntEventCode(0x44);
				}
				if (tc1.L21_event)
				{
					tc1.L21_event = FALSE;
					ProcessIntEventCode(0x1E);
				}
				if (tc1.read_event)
				{
					tc1.read_event = FALSE;
					ProcessIntEventCode(0x13);
				}

			}  
*/
	return bEvent;
}
//========================================================
/*
//======================================================================
//This is the function that will set flags based upon what
// interrupts (software) are generated by the PCI time code board
//
BOOL LookForEvent(void)
{

	ULONG		pAddr, d4, dLn;
	BOOLEAN		IOResult;
	BOOLEAN		status;
	UCHAR		iCd;
		status = TRUE;
		pAddr = 0x00000010;
		d4 = 0x00000000;
		//POLLED method
		IOResult = DoReadWriteAction(m_hAecDevice, GET_INT, pAddr, &d4, &dLn);

		// READ output---->
		if (IOResult)                            // Did the IOCTL succeed?
		{
			iCd = (UCHAR)d4;
			switch (iCd)
			{
			case (0x00):
				status = FALSE;
				break;
			case (0x13):	//tc reader interrupt (get time & user (don't worry about Embedded)			
				bRnew = TRUE;
				iReadCnt++;				
				pAddr = 0x00000010;//Read4 from 0x10 - TIME data -(RTM)
				d4 = 0x00000000;
				//Use 'RTM' to read the TIME data when polling. This 'code'
				//will read the PCI board registers till two reads in a
				//row are the same - ie: It is transient tollerant
				//when compared to the 'Read4' 'code' - also uses fixed address
				//of 0x10. 'RUB' does the same for the USER data at offset 0x14.
				//		AecGo(Read4, 0x10, 0x00);
				if (DoReadWriteAction(m_hAecDevice, Read4, pAddr, &d4, &dLn))	
				//if (DoReadWriteAction(m_hAecDevice, RTM, pAddr, &d4, &dLn))	
					lRTdat = d4;
				//pAddr = 0x00000014;//Read4 from 0x14 - USER data -(RUB)
				//d4 = 0x00000000;
				//if (DoReadWriteAction(m_hAecDevice, RUB, pAddr, &d4, &dLn))
				//	lRUdat = d4;
				break;
			case (0x4C):	//tc generator interrupt
				bGnew = TRUE;
				iGenCnt++;
				//NOTE: The Generator output registers have NOT been defined yet
				//		This will be done in later models of the PCI-TC boards
				pAddr = 0x00000040;//Read4 from 0x40 - generator TIME data 
				d4 = 0x00000000;
				if (DoReadWriteAction(m_hAecDevice, Read4, pAddr, &d4, &dLn))
					lGTdat = d4;
//				pAddr = 0x00000044;//Read4 from 0x44 - gen. USER data 
//				d4 = 0x00000000;
//				if (DoReadWriteAction(m_hAecDevice, Read4, pAddr, &d4, &dLn))
//					lGUdat = d4;
				break;

			case (0x44):	//Video field int
				//NOTE: 
				//This feature is NOT yet supported in the current PCI-TC models
				//At the time this software was written, only the PCI-LTC/RDR
				//was available.
				//calculate the number of video field interrupts / second ?
				iVidCnt++;
				bVnew = TRUE;
				// see if interrupts occur too fast or too slow - keep track?
//				QueryPerformanceCounter(&now);
//				if ( last.QuadPart )
//				{
//					DWORD n = (DWORD) ((now.QuadPart - last.QuadPart) / (frequency.QuadPart / 1000));
//					if ( n < min )
//						min = n;
//					if ( n > max )
//						max = n;	// **NEW***
//					if ( n > 17 )	// may need to change this value if not detecting
//						count += 1;	// 60 /Second video field rate interrupt.
//								//    Use '34' for 30 frame reader/gen
//								//    Use '41' for 25 frame reader/gen (PAL)
//								//    Use '21' for 50 field video rate interrupt (PAL)
//				}
//
//				last.QuadPart = now.QuadPart;

				break;

			default:	//command response, compare, serial...NAK
				iOtherCnt++;
			}
		}    
//		else 
//		{
//			Sleep(500);
//			MessageBeep(0xFFFFFFFF);
//		}
		return(status);        
}

====
    EDITTEXT        IDC_EDIT_TIME
    EDITTEXT        IDC_EDIT_USER
    EDITTEXT        IDC_EDIT_DF
    EDITTEXT        IDC_EDIT_CF
    EDITTEXT        IDC_EDIT_SELECTED
    EDITTEXT        IDC_EDIT_MODE
    EDITTEXT        IDC_EDIT_R1ADDR
    EDITTEXT        IDC_EDIT_R4ADDR
    EDITTEXT        IDC_EDIT_W1ADDR
    EDITTEXT        IDC_EDIT_W4ADDR
    EDITTEXT        IDC_EDIT_R1DATA
    EDITTEXT        IDC_EDIT_R4DATA
    EDITTEXT        IDC_EDIT_W1DATA
    EDITTEXT        IDC_EDIT_W4DATA
    EDITTEXT        IDC_EDIT_CMD
    EDITTEXT        IDC_EDIT_RESPONSE
    EDITTEXT        IDC_EDIT_FIELDCNT
    EDITTEXT        IDC_EDIT_STATUS
====



*/
//========================================================
void CAecMfcUSBDlg::ProcessIntEventCode(int IntId)
{
	DWORD dwTemp1, dwTemp2;
	BYTE  bTemp;
//	WORD  w[20];
//	DWORD  dw[10];
	int		i = 0;

//DWORD m_cmpRtb, m_cmpRub, cmpGtb, cmpGub;
//BYTE m_cmpReb, cmpGeb, m_cmp0C, m_cmp0D;

	switch (IntId)
	{
		case 0x11:	// LTC time code reader (PCI - if 2C.6 = '1')
		case 0x12:	// VITC time code reader (PCI - if 28.6 = '1')
		case 0x13:	//time code reader ID / AUTO (PCI & smart ISA)
			//IDC_EDIT_TIME, IDC_EDIT_USER, IDC_EDIT_DF, IDC_EDIT_CF
			dwTemp1 = R4(0x0010); //tc1.tcR.t ;
			dwTemp2 = R4(0x0014); //tc1.tcR.u;
			//bTemp = (tc1.tcR.e & 0xF3);	//mask the field (bit3/2 (NTSC/PAL)) to limit updates
//			bTemp = (R1(0x0018) & 0xF3);	//mask the field (bit3/2 (NTSC/PAL)) to limit updates
			//if (dwTemp1 != 0xFFFFFFFF)
			if (dwTemp1 != m_cmpRtb)
			{
				m_cmpRtb = dwTemp1;
				//sh1.DWStrTm(dwTemp1, hhmmssff);
				LtoStrTm(dwTemp1, hhmmssff);
				SetDlgItemText(IDC_EDIT_TIME, hhmmssff);
			}
			if (dwTemp2 != m_cmpRub)
			{
				m_cmpRub = dwTemp2;
				LtoStrTm(dwTemp2, hhmmssff);
				SetDlgItemText(IDC_EDIT_USER, hhmmssff);
			}
//			if (bTemp != m_cmpReb)
//			{
//				m_cmpReb = bTemp;
//				if (bTemp & 0x80)
//					SetDlgItemText(IDC_EDIT_DF, "YES");
//				else SetDlgItemText(IDC_EDIT_DF, "NO");
//				if (bTemp & 0x40)
//					SetDlgItemText(IDC_EDIT_CF, "YES");
//				else SetDlgItemText(IDC_EDIT_CF, "NO");;
//			}
			break;

		case 0x1E:	//Line 21 reader ID (VITC rdr mode & have 2E.6 = '1' 
//			//iL21Total++;
//			if (pDlgL21 != NULL)
//			{
//				//send to L21 dialog to handle the CC/XDS data!!
//				pDlgL21->ReceiveData(tc1.GetL21DwStr(dw, 8), dw);
//			}
//			else
//			{				
//				//(display to this edit box)
//				WriteHexStringToEditBox(IDC_EDIT_L21_OUT, tc1.GetL21DwStr(dw, 8), dw);	//dwords,not words
//				tc1.ResetL21Buffer();	//?
//			}
//			break;
//
			dwTemp1 = R4(0x0050); //tc1.tcR.t ;
			if (dwTemp1 != 0x00)
			{
				LtoStrTm(dwTemp1, hhmmssff);
				SetDlgItemText(IDC_EDIT_MODP1, hhmmssff);
			}
			dwTemp1 = R4(0x0054); //tc1.tcR.t ;
			if (dwTemp1 != 0x00)
			{
				LtoStrTm(dwTemp1, hhmmssff);
				SetDlgItemText(IDC_EDIT_MODP2, hhmmssff);
			}
			dwTemp1 = R4(0x0058); //tc1.tcR.t ;
			if (dwTemp1 != 0x00)
			{
				LtoStrTm(dwTemp1, hhmmssff);
				SetDlgItemText(IDC_EDIT_MODP3, hhmmssff);
			}
			dwTemp1 = R4(0x005C); //tc1.tcR.t ;
			if (dwTemp1 != 0x00)
			{
				LtoStrTm(dwTemp1, hhmmssff);
				SetDlgItemText(IDC_EDIT_MODP4, hhmmssff);
			}
			//IDC_EDIT_MODP1, IDC_EDIT_MODP2, IDC_EDIT_MODP3, IDC_EDIT_MODP4
			break;

		case 0x44:	//video field ID
		case 0x45:	//video SUB field interrupt ID (custom firmware)

		//		iFieldsTotal = tc1.vidCounter;
		//		if (tmrVIDup.msT() > 150)   //only update so often at max
		//		{
		//			wsprintf (cBuff,"v%d", iFieldsTotal);
		//			SetDlgItemText(hwndDlg, AEC_VID_FRAMES, cBuff); 
		//			tmrVIDup.Zero();
		//		}
		//		break;
		//	
			m_vidcount++;
			wsprintf (hhmmssff,"%d", m_vidcount);
			SetDlgItemText(IDC_EDIT_FIELDCNT, hhmmssff); 
			break;

		case 0x50:	//time code compare MATCH ID				
			//CheckDlgButton(IDC_CHECK_CMPSTATUS, ((tc1.GetCmpStatus() & BIT7) ? 1 : 0));
			//SetDlgItemText(IDC_BUTTON_CMPSTART, "Enable/Start");
			//MessageBeep(-1);
			MessageBox( "MATCH!", "Time Code Comparator", MB_OK);
			//set up for next compare...???
			break;

		case 0xF0:	// NAK  error of some sort(0xFx)
		case 0xF1:
		case 0xF2:
		case 0xF3:
		case 0xF4:
		case 0xF5:
		case 0xF6:
		case 0xF7:
		case 0xF8:
		case 0xF9:
		case 0xFA:
		case 0xFB:
		case 0xFC:
		case 0xFD:
		case 0xFE:
		case 0xFF:
			MessageBox("Error code F?h", "Received Interrupt Code", MB_OK);
			break;
			//VGWE_Int, vitc generator write error ID
					//put code here to flag this error
		default:
			// ISR processing of command response interrupts
				// NOT used if using polling method!
			break;
	} //END of Interrupt ID cases
	return;// TRUE;
}
//==========================================================================
//		case 0x4C:	//time code generator ID		
//			dwTemp1 = tc1.tcG.t ;			
//			dwTemp2 = tc1.tcG.u;
//			bTemp = (tc1.tcG.e & 0xF3);	//mask the field (bit3/2 (NTSC/PAL)) to limit updates
//			if (dwTemp1 != cmpGtb)	//time
//			{
//				cmpGtb = dwTemp1;
//				LtoStrTm(dwTemp1, hhmmssff);
//				SetDlgItemText(IDC_EDIT_TBGEN_OUTPUT, hhmmssff);
//			}
//			if (dwTemp2 != cmpGub)	//user
//			{
//				cmpGub = dwTemp2;
//				LtoStrTm(dwTemp2, hhmmssff);
//				SetDlgItemText(IDC_EDIT_UBGEN_OUTPUT, hhmmssff);
//			}
//			if (bTemp != cmpGeb)	//eb
//			{
//				cmpGeb = bTemp;
//				if (bTemp & 0x80)
//					SetDlgItemText(IDC_EDIT_DFGEN_OUTPUT, "YES");
//				else SetDlgItemText(IDC_EDIT_DFGEN_OUTPUT, "NO");
//				if (bTemp & 0x40)
//					SetDlgItemText(IDC_EDIT_CFGEN_OUTPUT, "YES");
//				else SetDlgItemText(IDC_EDIT_CFGEN_OUTPUT, "NO");;
//			}
//			break;
//
//		case 0x8A:	//RX break  byte ID
////			if (iTimeOutEvents > 0)
////				iTimeOutEvents--;
////			tmrSIO.Zero();		//reset timer
////			if (*lpRxBusy) //*lpRxDone || 
////				RXready = TRUE;
//
//			if (pDlgSIO != NULL)
//			{
//				//send to SIO generic dialog
//			}
//			else if (pDlgSony422 != NULL)
//			{
//				//send to Sony422 dialog
//			}
//			else
//			{
//				//flush, not used
//			}
//
//			break;
//		case 0x88:	//RX data byte ID
//				//check for 10ms timeout
//				//flag error if timeout
//				//Put command in Que to read byte (0x82)
//				//reset 10ms timer
////			if (iTimeOutEvents > 0)
////				iTimeOutEvents--;
////
////			tmrSIO.Zero();		//reset timer
////			if (*lpRxBusy) //*lpRxDone || 
////				RXready = TRUE;
//			i++;
//			if (pDlgSIO != NULL)
//			{
//				//send to SIO generic dialog
//				pDlgSIO->ReceiveData(tc1.GetRxWStr(w, 20), w);
//			}
//			else if (pDlgSony422 != NULL)
//			{
//				//send to Sony422 dialog
//				pDlgSony422->ReceiveData(tc1.GetRxWStr(w, 20), w);
//
//			}
//			else
//			{
//				//IDC_EDIT_RX_OUT (display to this edit box)
//				WriteHexStringToEditBox(IDC_EDIT_RX_OUT, tc1.GetRxWStr(w, 10), w);
//			}
//			
//			break;
//
//		case 0x89:	//TX complete ID
//			iTimeOutEvents++;
////			if (iTimeOutEvents > 5) 
////			{
////				//MessageBeep(0xFFFFFFFF);	//remove after debugging
////				MessageBox( "The VTR is NOT responding."
////					"\nCheck cable","Serial IO", MB_OK);
////				// send a message to the SIO dialog box to close it
//////				PostMessage(hwndSIO, WM_COMMAND, IDCANCEL, 0);//close dialog if errors
////													//add back after debugging
////			}
////
////			//tc1.InitRx();
////
////			rxIndex = 0;
////			//inititialize/reset 10ms timer
////			tmrSIO.Zero(); 
////			if (*lpRxBusy && (rx_mode == OPTIONAL_RX))	// if not using rx interrupt modes
////				RXready = TRUE;
//
//			if (pDlgSIO != NULL)
//			{
//				//send to SIO generic dialog
//			}
//			else if (pDlgSony422 != NULL)
//			{
//				//send to Sony422 dialog
//				//tc1.InitRx();
//				pDlgSony422->TxComplete = TRUE;
//				//MessageBeep(-1);
//				i++;
//			}
//			else
//			{
//				//flush, not used
//			}
//
//			break;
//	

/*

  	if (nPort == 0x000000FC)	//debug value
	{
		c = 0x00;
		if (m_power)
			c = (c | 0x01);
		if (m_timein)
			c = (c | 0x02);
		if (m_timeout)
			c = (c | 0x04);
		if (m_MemoryDirect)
			c = (c | 0x08);
		pIOBuffer->value = (ULONG)c;
		I.Information() = sizeof(AECPCI_ACTION_ITEM);
		return status;
	}
	if (nPort == 0x000000FB)	//debug value
	{
		//toggle "m_MemoryDirect" value
		if (m_MemoryDirect)
		{
			m_MemoryDirect = false;
			pIOBuffer->value = 0x00;
		}
		else 
		{
			m_MemoryDirect = true;
			pIOBuffer->value = 0x01;
		}
		I.Information() = sizeof(AECPCI_ACTION_ITEM);
		return status;
	}
*/


//=========================================================
void CAecMfcUSBDlg::UpdateStatus_N_Signals()
{
	BYTE temp;
	BYTE tempD, tempC, direct;
	DWORD four0C, four00;


//	direct = R1(0x00FC);
//	if ((direct & 0x0010) != 0)
//		m_slowmo = true;
//	else m_slowmo = false;

//	if ((direct & 0x08) == 0x00)
//	{
//		direct = R1(0x00FB);
//		if (!direct)
//			MessageBox("direct error", "USB data", MB_OK);
//	}

	//Device ID status (00-03h)=====================================
//	four00 = R4(0x0000);
//	four00 = R4(0x0000);
	//Operating mode status (0Dh)=====================================
///	four0C = R4(0x000C);
//	four0C = R4(0x000C);
	temp = R1(0x000D);	//pci
///	if (four0C == 0x4F000000)
///		return;
///	temp = (BYTE)((four0C & 0x0000FF00) >> 0x08);
	tempD = temp;	//save for later
/*		
	if ((temp & 0x0F) != m_ByteDActive)
	{
		m_ByteDActive = (temp & 0x0F);
		m_ByteDSelected = 0xFF;
		if ((m_ByteDActive & 0x0F) == 0x03)
		{
			wsprintf (hhmmssff,"AUTO");
			SetDlgItemText(IDC_EDIT_MODE, hhmmssff);
		}
		else if ((m_ByteDActive & 0x0F) == 0x01)
		{
			wsprintf (hhmmssff,"LTC");
			SetDlgItemText(IDC_EDIT_MODE, hhmmssff);
		}
		else if ((m_ByteDActive & 0x0F) == 0x02)
		{
			wsprintf (hhmmssff,"V/L21");
			SetDlgItemText(IDC_EDIT_MODE, hhmmssff);
		}
	}

	if ((temp & 0xF0) != m_ByteDSelected)
	{
		m_ByteDSelected = (temp & 0xF0);
		if ((m_ByteDSelected & 0x20) == 0x20)	//LTC=1, VITC=0
		{
			if (m_ByteDActive & 0x01)
			{
				wsprintf (hhmmssff,"LTC");
				SetDlgItemText(IDC_EDIT_SELECTED, hhmmssff);
			}
			else 
			{
				wsprintf (hhmmssff,"???");
				SetDlgItemText(IDC_EDIT_SELECTED, hhmmssff);
			}
		}
		else
		{
			if (m_ByteDActive & 0x02)
			{
				wsprintf (hhmmssff,"VITC");
				SetDlgItemText(IDC_EDIT_SELECTED, hhmmssff);
			}
			else
			{
				wsprintf (hhmmssff,"???");
				SetDlgItemText(IDC_EDIT_SELECTED, hhmmssff);
			}
		}
	}

*/
//			wsprintf (hhmmssff,"%d", temp);	// %2.2X
//			wsprintf (hhmmssff,"VITC");	// %2.2X
//			SetDlgItemText(IDC_EDIT_MODE, hhmmssff);
			//IDC_EDIT_SELECTED
	//m_ByteDActive
	//m_ByteDSelected
//*
	if (m_cmp0D != temp)
	{
		//( wOffset < 0x50 ) ? 0x10 : 0x20
		if ((m_cmp0D & 0x80 ) != (temp & 0x80))	//7
			CheckDlgButton(IDC_CHECK_DIAGMODE, ((temp & 0x80) ? 1 : 0));
		//if ((m_cmp0D & 0x40 ) != (temp & 0x40))	//6
		//	CheckDlgButton(nID, ((temp & 0x40) ? 1 : 0));
		if ((m_cmp0D & 0x20 ) != (temp & 0x20))	//5
		{
			CheckDlgButton(IDC_CHECK_LTCSELECTMODE, ((temp & 0x20) ? 1 : 0));
			CheckDlgButton(IDC_CHECK_VITCSELECTMODE, ((temp & 0x20) ? 0 : 1));
		}


//		if (filmAble)
//		{

			if ((m_cmp0D & 0x50 ) != (temp & 0x50))	// 6/4
			{
				if (temp & 0x40)
				{
					//CheckDlgButton(IDC_CHECK_FILMMODE, ((temp & 0x40) ? 1 : 0));
					CheckDlgButton(IDC_CHECK_FILMMODE, 1);
					CheckDlgButton(IDC_CHECK_EBUMODE, 0);	//Not in this mode
					CheckDlgButton(IDC_CHECK_SMPTEMODE,0);	//Not in this mode
				}
				else
				{
					CheckDlgButton(IDC_CHECK_EBUMODE, ((temp & 0x10) ? 1 : 0));
					CheckDlgButton(IDC_CHECK_SMPTEMODE, ((temp & 0x10) ? 0 : 1));
					CheckDlgButton(IDC_CHECK_FILMMODE, 0);
				}
			}
//		}
//		else if ((m_cmp0D & 0x10 ) != (temp & 0x10))	//4
//		{
//			CheckDlgButton(IDC_CHECK_EBUMODE, ((temp & 0x10) ? 1 : 0));
//			CheckDlgButton(IDC_CHECK_SMPTEMODE, ((temp & 0x10) ? 0 : 1));
//		}
//

//		if ((m_cmp0D & 0x08 ) != (temp & 0x08))	//3
//		{
//			CheckDlgButton(IDC_CHECK_VGENMODE, ((temp & 0x08)  ? 1 : 0 ));		
//			//CheckDlgButton(IDC_CHECK_VGENMODE, (temp & 0x08));
//			//CheckDlgButton(IDC_CHECK_GEN_VITC, ((temp & 0x08)  ? 1 : 0 ));
//		}
//		if ((m_cmp0D & 0x04 ) != (temp & 0x04))	//2
//		{
//			CheckDlgButton(IDC_CHECK_LGENMODE, ((temp & 0x04)  ? 1 : 0 ));
//			//CheckDlgButton(IDC_CHECK_LGENMODE, (temp & 0x04));
//			//CheckDlgButton(IDC_CHECK_GEN_LTC, ((temp & 0x04)  ? 1 : 0 ));
//		}
		if ((m_cmp0D & 0x02 ) != (temp & 0x02))	//1
		{
			CheckDlgButton(IDC_CHECK_VL21RDRMODE, ((temp & 0x02)  ? 1 : 0 ));
			//CheckDlgButton(IDC_CHECK_VL21RDRMODE, (temp & 0x02));
			//CheckDlgButton(IDC_CHECK_READ_VITC, ((temp & 0x02)  ? 1 : 0 ));
		}
		if ((m_cmp0D & 0x01 ) != (temp & 0x01))	//0
		{
			CheckDlgButton(IDC_CHECK_LRDRMODE, ((temp & 0x01)  ? 1 : 0 ));
			//CheckDlgButton(IDC_CHECK_LRDRMODE, (temp & 0x01));
			//CheckDlgButton(IDC_CHECK_READ_LTC, ((temp & 0x01)  ? 1 : 0 ));

		}

		m_cmp0D = temp;
	}
//	
//					if (IsDlgButtonChecked(hwndDlg, AEC_INT_READ_OFF)) 
//						bReadOff = TRUE; // bit 0
//					else bReadOff = FALSE;
//     
//*/
	//signal status (0Ch)==========================================
///	temp = (BYTE)(four0C & 0x0000007F);
	temp = R1(0x000C);	//pci

	//temp = (R1(0x000C) & 0x7F);   //pci, mask bit7
			//		 bits  => 6=L21 input data OK,
							//5=VITC input data OK
							//4=LTC input data OK
							//3=Wide sync pluses detected
							//2=
							//1=odd video field
							//0=video input OK
	tempC = temp;	//save for later
	
			wsprintf (hhmmssff,"%2.2X-%2.2X", tempD, tempC);
			SetDlgItemText(IDC_EDIT_STATUS, hhmmssff);

//*
	if (m_cmp0C != temp)
	{
		//IDC_CHECK_FIELDSTAT
		//if ((m_cmp0C & 0x80 ) != (temp & 0x80))
		//	CheckDlgButton(nID, ((temp & 0x80)  ? 1 : 0 ));
		if ((m_cmp0C & 0x40 ) != (temp & 0x40))	//6
			CheckDlgButton(IDC_CHECK_L21STAT, ((temp & 0x40)  ? 1 : 0 ));
		if ((m_cmp0C & 0x20 ) != (temp & 0x20))	//5
			CheckDlgButton(IDC_CHECK_VITCSTAT, ((temp & 0x20)  ? 1 : 0 ));
		if ((m_cmp0C & 0x10 ) != (temp & 0x10))	//4
			CheckDlgButton(IDC_CHECK_LTCSTAT, ((temp & 0x10)  ? 1 : 0 ));

		if ((m_cmp0C & 0x08 ) != (temp & 0x08))	//3
			CheckDlgButton(IDC_CHECK_VSYNCSTAT, ((temp & 0x08)  ? 1 : 0 ));

		if ((m_cmp0C & 0x01 ) != (temp & 0x01))	//0
			CheckDlgButton(IDC_CHECK_VIDSTAT, ((temp & 0x01)  ? 1 : 0 ));
		m_cmp0C = temp;
	}

	m_dataset = false;
	if (four00 == 0x6600AECB)
	{
		m_dataset = true;		
		//toggle the "data" path ok
		//if(m_dataset)
//			CheckDlgButton(IDC_CHECK_USBDATAOK, (m_dataset  ? 1 : 0 ));
		//else
		//	CheckDlgButton(IDC_CHECK_USBDATAOK, ((temp & 0x10)  ? 1 : 0 ));
		//m_dataset = !m_dataset;
	}
	if (four00 == 0x6610AECB)
	{
		m_dataset = true;		
	}
	CheckDlgButton(IDC_CHECK_USBDATAOK, (m_dataset  ? 1 : 0 ));


/*
	//Interupt Enables (2E/3F0)==========================================
	temp = (R1(0x002E) & 0x7F);   //pci, mask bit7
			//		 bits  => 6= L21 Data Reader
							//5= TC comparator
							//4= Serial RX
							//3= Serial TX
							//2= TC Gen
							//1= video Field 
							//0= TC Reader 
	if (m_cmp2E != temp)
	{
		//if ((m_cmp2E & 0x80 ) != (temp & 0x80))	//7
		//	CheckDlgButton(nID, ((temp & 0x80) ? 1 : 0));
		if ((m_cmp2E & 0x40 ) != (temp & 0x40))	//6
			CheckDlgButton(AEC_CHECK_INT_L21ON, ((temp & 0x40) ? 1 : 0));
		if ((m_cmp2E & 0x20 ) != (temp & 0x20))	//5
			CheckDlgButton(AEC_CHECK_INT_CMPON, ((temp & 0x20) ? 1 : 0));
		if ((m_cmp2E & 0x10 ) != (temp & 0x10))	//4
			CheckDlgButton(AEC_CHECK_INT_RXON, ((temp & 0x10) ? 1 : 0));

		if ((m_cmp2E & 0x08 ) != (temp & 0x08))	//3
			CheckDlgButton(AEC_CHECK_INT_TXON, ((temp & 0x08)  ? 1 : 0 ));
		if ((m_cmp2E & 0x04 ) != (temp & 0x04))	//2
			CheckDlgButton(AEC_CHECK_INT_GENON, ((temp & 0x04)  ? 1 : 0 ));
		if ((m_cmp2E & 0x02 ) != (temp & 0x02))	//1
			CheckDlgButton(AEC_CHECK_INT_VIDON, ((temp & 0x02)  ? 1 : 0 ));
		if ((m_cmp2E & 0x01 ) != (temp & 0x01))	//0
			CheckDlgButton(AEC_CHECK_INT_RDRON, ((temp & 0x01)  ? 1 : 0 ));
		m_cmp2E = temp;
	}

	BYTE temp = R1(0x2E);
	//7
	CheckDlgButton(IDC_CHECK_INTENABLE_L21, ((temp & 0x40) ? 1 : 0));
	CheckDlgButton(AEC_CHECK_INIDC_CHECK_INTENABLE_COMPARE, ((temp & 0x20) ? 1 : 0));
	//4

	//3
	//2
	CheckDlgButton(IDC_CHECK_INTENABLE_VIDEO, ((temp & 0x02)  ? 1 : 0 ));
	CheckDlgButton(IDC_CHECK_INTENABLE_READER, ((temp & 0x01)  ? 1 : 0 ));
	m_cmp2E = temp;
*/
}


//=========================================================
//Convert a LONG (4byte) value into a character string of TIME (Tm)
//This does NOT mask embedded bits 
// use "dw = (dw & 0x3F7F7F3F);" to mask embedded bits IF needed
//before calling this routine.
//------------------------------------------------------------
int CAecMfcUSBDlg::LtoStrTm(ULONG dw, char *chs)
{
	wsprintf (chs,"%8.8X",dw);
	chs[11] = 0;	//EOL
	chs[10] = chs[7];
	chs[9] = chs[6];
	chs[8] = ':';
	chs[7] = chs[5];
	chs[6] = chs[4];
	chs[5] = ':';
	chs[4] = chs[3];
	chs[3] = chs[2];
	chs[2] = ':';
	return 11;
}

//=========================================================
//BOOL DoReadWriteAction(
//				  IN HANDLE hOpen, 
//				  IN enum AECPCI_ACTION act, //IN enum AECPCI_ACTION_ITEM act, 
//				  IN ULONG port,
//				  IN OUT PULONG pdata,
//				  IN PULONG pLB
//				  )
//DoReadWriteAction(m_hAecDevice, Write1, portaddress, &data4, &len);
//
//=======================================================================
//-----------------------------------------------------------
//++	****** DEFINED ACTIONS SUPPORTED BY THE DRIVER ******
//AECPCI_ACTION_ITEM parameter must be one of the following!
//NOTE: The values ARE case sensitive!
//
//    NOP_THING,         //  No operation		0                   0
//    Read1,              //  input byte			offset				data (in)	
//    Read2,              //  input word			offset				data (in)
//    Read4,              //  input long			offset				data (in)
//    Write1,             //  output byte			offset				data (out)
//    Write2,             //  output word 		offset				data (out)
//    Write4,             //  output long 		offset				data (out)
//
//	SND_CMD,		//send command			command(out)		intcode(in)
//					//read the NEXT INTCODE - fixed OFFSET read / enable next
//	GET_INT			//get int code			0 (don't care?)		intcode(in)
//					//
//	RTM,			//  input long			0 (don't care?)		data (out)
//					//Read the TIME bits at offset 10h (transition tolerent) DWORD
//	RUB,			//  input long			0 (don't care?)		data (out)
//					//Read the USER bits at offset 14h (transition tolerent) DWORD
//	REB,			//  input byte			0 (don't care?)		data (out)
//					//Read the EMBEDDED bits at offset 18h (transition tolerent) UCHAR
//	NextInt,		//  output byte			0 (don't care)		data (out)
//					//Queue an IRP for the ISR/DPC to complete
//
//
BOOL CAecMfcUSBDlg::DoReadWriteAction(ULONG act, ULONG port, PULONG pdata)
{
	BOOL status = false;
	AECPCI_ACTION_ITEM		ai;			// *PAECPCI_ACTION_ITEM;
	DWORD nOutput = 0;

	ai.action = (AECPCI_ACTION)act;
	ai.port = port;
	ai.value = *pdata;

	//Nonzero indicates success. 
	//Zero indicates failure. 
	//To get extended error information, call GetLastError. 

	//status = TRUE;		//TEMP debug
	//*pdata = 0x13;		//TEMP debug

	if (m_hAecDevice != INVALID_HANDLE_VALUE)        // Was the device opened?
	{
		if (status = DeviceIoControl(		
                m_hAecDevice,			//1 Handle to device
                IOCTL_AECPCI_PROCESS_BUFFER,//2 IO Control code -- (Read)/ (Write)
								//pointer to buffer to supply input data
				&ai,			//3++ Buffer to driver.  Holds port & data (if any).
								//size of input buffer
				sizeof(ai),		//4+++ Length of buffer in bytes.
								//pointer to buffer to receive output data
                &ai,			//5++++ Buffer from driver.
								//size of output buffer
                sizeof(ai),		//6+++++ Length of buffer in bytes. 1/2/4 (char/word/dword)
								//pointer to variable to receive output byte count
				&nOutput,			//7 Bytes placed in DataBufferOut. (store # upon return)
                NULL			//8 NULL means wait till op. completes.
                )				
			)
		{		*pdata = ai.value;		}
	}

	return status;
}
//	{		
//		printf("Action = %d, port = %0X, data = %8.8X \n", ai.action, ai.port, ai.value);
//		Sleep(5);
//	}
//	else
//	{
//		printf("ERROR: DeviceIoControl returns %0x.", GetLastError());
//		Exit(1);
//	}
//==========================================================
BYTE CAecMfcUSBDlg::R1(ULONG addr)
{
//Read1\2\4, Write1\2\4, SND_CMD, GET_INT, NextInt
	ULONG data;
	DoReadWriteAction(Read1, addr, &data);
	return (BYTE)data;
}

//==========================================================
ULONG CAecMfcUSBDlg::R4(ULONG addr)
{
	ULONG data;
	DoReadWriteAction(Read4, addr, &data);
	return data;
}

//==========================================================
void CAecMfcUSBDlg::W1(ULONG addr, BYTE data1)
{
	ULONG data;
	data = (ULONG)data1;
	DoReadWriteAction(Write1, addr, &data);
}

//==========================================================
void CAecMfcUSBDlg::W4(ULONG addr, ULONG data4)
{
	ULONG data;
	data = data4;
	DoReadWriteAction(Write4, addr, &data);
}

//==========================================================
BYTE CAecMfcUSBDlg::SndCmd(BYTE cmd)
{
	ULONG port, data;
	data = 0;
	port = (ULONG)cmd;
	DoReadWriteAction(SND_CMD, port, &data);
	return (BYTE)data;
}

//==========================================================
BYTE CAecMfcUSBDlg::CheckForInt()
{
	ULONG port, data;
	data = 0;
	port = 0;
	DoReadWriteAction(GET_INT, port, &data);
	return (BYTE)data;
//	return 0x13;
}
//==========================================================

void CAecMfcUSBDlg::OnButtonR1Go() 
{
	// read one byte and write back to
	//       edit box.

	char	sOffset[3];
	WORD    wOffset;
	BYTE	BRone;

	if (GetDlgItemText(IDC_EDIT_R1ADDR,sOffset,4))
	{
		wOffset = (WORD)sh1.ToHex(sOffset);
		if (wOffset < 0x100)
		{
			BRone = R1((ULONG)wOffset);
			//DISPLAY DATA
			sh1.BStr(BRone, hhmmssff);
			SetDlgItemText(IDC_EDIT_R1DATA, hhmmssff);
		}
		else SetDlgItemText(IDC_EDIT_R1DATA, "Err");
	}
	else SetDlgItemText(IDC_EDIT_R1DATA, "Err"); 		
}

//==========================================================
void CAecMfcUSBDlg::OnButtonR4Go() 
{
	// read four bytes and write back to
	//       edit box.
	char	sOffset[3];
	WORD    wOffset;
	DWORD	dRfour;

	if (GetDlgItemText(IDC_EDIT_R4ADDR,sOffset,4))
	{
		wOffset = (WORD)sh1.ToHex(sOffset);
		if (wOffset < 0xFC)
		{
			dRfour = R4((ULONG)wOffset);//tc1.Read4(wOffset);
			//DISPLAY DATA
			LtoStrTm(dRfour, hhmmssff);
			SetDlgItemText(IDC_EDIT_R4DATA, hhmmssff);
		}
		else SetDlgItemText(IDC_EDIT_R4DATA, "Addr Err");
	}
	else SetDlgItemText(IDC_EDIT_R4DATA, "Error"); 	
}

//==========================================================
void CAecMfcUSBDlg::OnButtonW1Go() 
{
	// write one byte to TC device

	char	sOffset[3];
	char	sBuffer[4];
	WORD    wOffset;
	BYTE	BWone;
	//BOOL	bWrite;

	if ((GetDlgItemText(IDC_EDIT_W1ADDR,sOffset,4)) &&
		(GetDlgItemText(IDC_EDIT_W1DATA, sBuffer, 3)))
	{
		wOffset = (WORD)sh1.ToHex(sOffset);
		if (wOffset < 0x100)	//TODO: make address ranges ok for PCI too. (<FCh)
		{
			BWone = (BYTE)sh1.ToHex(sBuffer);
			//W1(BWone, wOffset);//tc1.Write1(BWone, wOffset);
			W1((ULONG)wOffset, BWone);
			//DISPLAY DATA/status
			sh1.BStr(BWone, hhmmssff);
			SetDlgItemText(IDC_EDIT_W1DATA, hhmmssff);
		}
		else SetDlgItemText(IDC_EDIT_W1ADDR, "AEr");
	}
	else SetDlgItemText(IDC_EDIT_W1ADDR, "Err");
}

//==========================================================
void CAecMfcUSBDlg::OnButtonW4Go() 
{
	char	sOffset[3];
	char	sBuffer[12];
	WORD    wOffset;
	DWORD	dWfour;
	//BOOL	bWrite;

	// write four bytes to TC device
	if ((GetDlgItemText(IDC_EDIT_W4ADDR,sOffset,4)) &&
		(GetDlgItemText(IDC_EDIT_W4DATA, sBuffer, 12)))
	{
		wOffset = (WORD)sh1.ToHex(sOffset);
		if (wOffset < 0xFD)	//TODO: make address ranges ok for PCI too. (<FDh)
		{
			dWfour = (DWORD)sh1.ToHex(sBuffer);
			//W4(dWfour, wOffset);//tc1.Write4(dWfour, wOffset);
			W4(wOffset, dWfour);
			LtoStrTm(dWfour, hhmmssff);
			SetDlgItemText(IDC_EDIT_W4DATA, hhmmssff);
		}
		else SetDlgItemText(IDC_EDIT_W4ADDR, "AEr");
	}
	else SetDlgItemText(IDC_EDIT_W4DATA, "Error");  	
}

//==========================================================
void CAecMfcUSBDlg::OnButtonCmdGo() 
{

	BYTE BWone, BRone;
	char	sBuffer[3];


	// TODO: Add code to send command to TC device
	if (GetDlgItemText(IDC_EDIT_CMD, sBuffer, 3))
	{
		BWone = (BYTE)sh1.ToHex(sBuffer);
		BRone = SndCmd(BWone);//tc1.SendCom(BWone);
			//DISPLAY DATA


		//Code here to put '??' when the returned ACK/NAK code
		// is NOT an allowed value for PROPER operation.
		if (BRone != BWone) //could have an error
		{
			//see if command is 2x and return value is 2x
			if ((BRone & 0x20) == (BWone  & 0x20))
				sh1.BStr(BRone, hhmmssff);
			else
			{
				sh1.BStr(BRone, hhmmssff);
				hhmmssff[2] ='?';
				hhmmssff[3] = 0;
			}
		}
		else
			sh1.BStr(BRone, hhmmssff);
		
		SetDlgItemText(IDC_EDIT_RESPONSE, hhmmssff);
	}
	else SetDlgItemText(IDC_EDIT_RESPONSE, "???"); 
	//InitGenStatus();	
}

//==========================================================
void CAecMfcUSBDlg::OnCheckSlowmo() 
{
	BYTE b;
	// TODO: Add your control notification handler code here
	//IDC_CHECK_SLOWMO
	b = R1(0x00FC);
	if ((b & 0x0010) != 0)
		m_slowmo = true;
	else m_slowmo = false;

	if (IsDlgButtonChecked(IDC_CHECK_SLOWMO))
	{
		if (!m_slowmo)
			b = R1(0x00F8);	//set slowmo from "clear/not slowmo" 
	}
	else
	{
		if (m_slowmo)
			b = R1(0x00F8);	//clear "set"
	}	

	b = R1(0x00FC);
	if ((b & 0x0010) != 0)
		m_slowmo = true;
	else m_slowmo = false;
}

//==========================================================
void CAecMfcUSBDlg::OnButtonL21() 
{
	// TODO: Add your control notification handler code here
	//IDC_BUTTON_L21
	W4(0x00000020, 0x80808080);
	SndCmd(0x5A);
	W1(0x0000002E, 0x00000043);
	SndCmd(0x23);
}
