// AecUsbTCioctl.h
//
// Define control codes for AecUsbTC driver
//

#ifndef __AecUsbTCioctl__h_
#define __AecUsbTCioctl__h_


#define AecUsbTCDevice_CLASS_GUID \
 { 0x70528942, 0x4a04, 0x42d6, { 0x81, 0xfd, 0xaf, 0xa1, 0xe7, 0x19, 0xcc, 0xfe } }


#define	BIT0	0x01
#define	BIT1	0x02
#define	BIT2	0x04
#define	BIT3	0x08
#define	BIT4	0x10
#define	BIT5	0x20
#define	BIT6	0x40
#define	BIT7	0x80


// Device type           -- in the "User Defined" range."
#define AECPCI_TYPE 40000


// ----------------------------------------------------------------------------
// Device type 
#define AecPciTC 40010
#define AEC_TYPE 40010
// The Device IOCTL function codes
        // Process AECPCI command buffer
        //   input/output:  use array of AECPCI_ACTION_ITEMs for input & output
//#define AECUSBTC_IOCTL_910 CTL_CODE(FILE_DEVICE_UNKNOWN, 0x910, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_AECPCI_PROCESS_BUFFER \
    CTL_CODE( AEC_TYPE, 0xA00, METHOD_BUFFERED, FILE_ANY_ACCESS )

//  -- */
// ----------------------------------------------------------------------------

//typedef struct  _GENPORT_WRITE_INPUT {
//    ULONG   PortNumber;     // Port # to write to
//    union   {               // Data to be output to port
//        ULONG   LongData;
//        USHORT  ShortData;
//        UCHAR   CharData;
//    };
//}   GENPORT_WRITE_INPUT;
// ----------------------------------------------------------------------------

enum AECPCI_ACTION  // ACTION for AECPCI_ACTION_ITEM "action" buffer
{                      // action naming convention:
                        //       data size
                        //     1 - byte  8 bits,   2 - word 16 bits,  4 - long 32 bits
                        //       port or memory mapped I/O from base address of device
                        //                  param1            param2
    NOP_THING,         //  No operation		0                   0	//DONT'T USE
    Read1,              //  input byte			offset				data (in)	
    Read2,              //  input word			offset				data (in)
    Read4,              //  input long			offset				data (in)
    Write1,             //  output byte			offset				data (out)
    Write2,             //  output word 		offset				data (out)
    Write4,             //  output long 		offset				data (out)

	R256=256,		//NOT supported YET! - (fixed offset write/read... operation)
	SND_CMD,		//send command			command(out)		intcode(in)
					//read the NEXT INTCODE - fixed OFFSET read / enable next
	GET_INT,		//get int code			0 (don't care?)		intcode(in) UCHAR
	RTM,			//  input long			0 (don't care?)		data (out)
					//Read the TIME bits at offset 10h (transition tolerent) DWORD
	RUB,			//  input long			0 (don't care?)		data (out)
					//Read the USER bits at offset 14h (transition tolerent) DWORD
	REB,			//  input byte			0 (don't care?)		data (out)
					//Read the EMBEDDED bits at offset 18h (transition tolerent) UCHAR
	NextInt,		//  output byte			0 (don't care)		data (out)
					//Queue an IRP for the ISR/DPC to complete
	GGT,			//*  input long			0 (don't care?)		data (out)
					//Read (Get Generator) TIME bits at offset 40h (uses VALIDATION) DWORD

	GGU,			//*  input long			0 (don't care?)		data (out)
					//Read (Get Generator) USER bits at offset 44h (uses VALIDATION) DWORD

	GGE,			//*  input byte			0 (don't care?)		data (out)
					//Read (Get Generator) EMBEDDED bits at offset 48h (uses VALIDATION) UCHAR
					//** GGT, GGU, GGE New for Win2K/XP driver ONLY Oct 2002

	//-----------------------------------------------------------------------
	LAST			//nothing!
}; 

// ----------------------------------------------------------------------------
            // Process buffer item for input to IOCTL_AECPCI_PROCESS_BUFFER
            //                              and IOCTL_AECPCI_WAIT_ON_INTERRUPT
typedef struct _AECPCI_ACTION_ITEM
{
    //enum AECPCI_ACTION  action; // action to perform
    AECPCI_ACTION  action; // action to perform
    ULONG               port;       // port address
    ULONG               value;      // input or output data
} AECPCI_ACTION_ITEM, *PAECPCI_ACTION_ITEM;
// ----------------------------------------------------------------------------

        // AecIOAction - process an input/output buffer
        //     Inputs:  h  - handle to device 
        //                  (returned from OpenDevice())
        //              pBuf - pointer to i/o buffer
        //                  (array of type AECPCI_ACTION_ITEM)
        //              size  - size off i/o buf       
        //     Outputs: pLen  - pointer to variable which contains
        //                  length of returned buffer (DWORD)
        //              returns - error if zero
        //                   (call GetLastError() to error code)                     
        //      notes: pB is both an input & output
#define AecIOAction(hAecDev,pBuf,size,pLen)\
            DeviceIoControl(\
                hAecDev, (DWORD)IOCTL_AECPCI_PROCESS_BUFFER,\
                pBuf, size, pBuf, size, pLen, NULL)

// ----------------------------------------------------------------------------


#endif
